import objectdraw.*;
import java.awt.*;
import java.util.Random;
import javax.swing.JSlider;

/*
 * 
 * Example FallingSnow: the cloud class which is responsible for
 * creating a bunch of snowflakes, this one passing through a
 * JSlider to control "wind" to the snowflakes when created.
 *
 * Jim Teresco, Siena College, CSIS 120, Spring 2011
 * The College of Saint Rose, Fall 2013, Fall 2014
 * Based on example from CSCI 134, Williams College
 *
 * $Id: Cloud.java 2452 2014-10-13 15:59:20Z terescoj $
 */

public class Cloud extends ActiveObject {

    // total number of snowflakes
    private static final int MAX_SNOW = 150;
    // time between flakes
    private static final int FLAKE_INTERVAL = 900;

    // the canvas
    private DrawingCanvas canvas;

    // picture of a snowflake
    private Image snowPic;

    // used to generate random speeds and positions for snowflakes
    private Random snowGen;
    
    // our Wind generator
    private JSlider wind;

    public Cloud(Image aSnowPic, JSlider wind, DrawingCanvas aCanvas) {

        // save the parameters for the "run" method
        canvas = aCanvas;
        snowPic = aSnowPic;
        this.wind = wind;
 
        snowGen = new Random();

        start();
    }

    public void run()
    {
        int snowCount= 0;

        // continue creating snow until the maximum amount
        // has been created
        while (snowCount < MAX_SNOW ) {

            snowCount = snowCount + 1;

            new FallingSnow(canvas, snowPic, wind,
                            snowGen.nextInt((int)canvas.getWidth()),   // x coordinate
                            snowGen.nextDouble()*2+2); // y speed
            pause(FLAKE_INTERVAL);
        }
    }
}